ghc-7.0.3: The GHC API

SMRep

# Documentation

type StgWord = Word32

type StgHalfWord = Word16

hALF_WORD_SIZE :: ByteOff

hALF_WORD_SIZE_IN_BITS :: Int

type WordOff = Int

type ByteOff = Int

data CgRep

Constructors

VoidArg |
PtrArg |
NonPtrArg |
LongArg |
FloatArg |
DoubleArg |

Instances

Eq CgRep |
Outputable CgRep |

nonVoidArg :: CgRep -> Bool

argMachRep :: CgRep -> CmmType

primRepToCgRep :: PrimRep -> CgRep

isFollowableArg :: CgRep -> Bool

isVoidArg :: CgRep -> Bool

isFloatingArg :: CgRep -> Bool

is64BitArg :: CgRep -> Bool

separateByPtrFollowness :: [(CgRep, a)] -> ([(CgRep, a)], [(CgRep, a)])

cgRepSizeW :: CgRep -> ByteOff

cgRepSizeB :: CgRep -> ByteOff

retAddrSizeW :: WordOff

typeCgRep :: Type -> CgRep

idCgRep :: Id -> CgRep

tyConCgRep :: TyCon -> CgRep

data SMRep

Constructors

GenericRep Bool !Int !Int ClosureType |
BlackHoleRep |

data ClosureType

Constructors

Constr |
ConstrNoCaf |
Fun |
Thunk |
ThunkSelector |

isStaticRep :: SMRep -> Bool

fixedHdrSize :: WordOff

arrWordsHdrSize :: ByteOff

arrPtrsHdrSize :: ByteOff

profHdrSize :: WordOff

thunkHdrSize :: WordOff

smRepClosureType :: SMRep -> Maybe ClosureType

smRepClosureTypeInt :: SMRep -> StgHalfWord

rET_SMALL :: StgHalfWord

rET_BIG :: StgHalfWord